
from qt import *

class FolderItem(QListViewItem):
    def __init__(self, p, fileName, root):
        apply(QListViewItem.__init__, (self, p))
        
        self.f = QFile(unicode(fileName))
        
        if root:
            self.__parent = None
            self.setOpen(False)
        else:
            self.__parent = p
            self.setPixmap(0, QPixmap("pics/folder.png"));
    
    def text(self, n):
        return self.f.name()
    
    def name(self):
        return self.text(0)
    
    def fileName(self):
        if self.__parent:
            return self.__parent.fileName()+unicode(self.f.name())+'/'
        else:
            return unicode(self.f.name())
    
    def setOpen(self, o):
        if o: self.setPixmap(0, QPixmap("pics/folder_open.png"))
        else: self.setPixmap(0, QPixmap("pics/folder.png"))
        
        if self.fileName()=='/':
            self.setPixmap(0, QPixmap("pics/drive.png"))
            
        if self.fileName()==unicode(QDir.home().path())+'/':
            self.setPixmap(0, QPixmap("pics/folder_home.png"))
        
        if o and not self.childCount():
            fdir = QDir(self.fileName())
            if not fdir.isReadable():
                self.setExpandable(False)
                return QListViewItem.setOpen(self, o)
            
            self.listView().setUpdatesEnabled(False)
            
            fl = fdir.entryInfoList()
            
            if fl:
                for fi in fl:
                    if fi.fileName()=="." or fi.fileName()=="..":
                        pass
                    elif fi.isDir() or ( fi.isDir() and fi.isSymLink() ):
                        folder = FolderItem(self, fi.fileName(), False )
            
            self.listView().setUpdatesEnabled(True)
            
        return QListViewItem.setOpen(self, o)
    
    def setup(self):
        fdir = QDir(self.fileName())
        
        if not fdir.isReadable():
            self.setExpandable(False)
        elif len(fdir.entryInfoList(QDir.Dirs + QDir.NoSymLinks))>2:
            self.setExpandable(True)
        
        return QListViewItem.setup(self)